<template>
  <div class="stars">
    <h1 class="first-letter-colored is-capitalized"
        :class="{ 'is-size-6': isSmall(),
                  'is-size-4': isLarge(),
                  'mb-3': isSmall(),
                  'mb-6': isLarge() }">
      {{ $t('sidebar.stars.title') }}
    </h1>
    <section class="has-text-centered">
      <template v-for="color in ['green', 'orange', 'red']">
        <star :key="'icon' + color"
                :custom-size="getIconSize()"
                :type="color"
                :class="{ 'mx-4': isSmall(),
                          'mx-5': isLarge() }" />
        <span :key="'count' + color"
              class="has-text-weight-bold"
              :class="{ 'is-size-6': isSmall(),
                        'is-size-3': isLarge() }">
          {{ cachedStars[color] || 0 }}
        </span>
      </template>
    </section>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from 'vue-property-decorator';

import Star from '@/components/Star.vue';
import { StarObject } from '@/types/scores';
import { MapState } from '@/decorators';
import { Size } from '@/types/sizes';

@Component({
  components: { Star }
})
export default class Stars extends Vue {
  @MapState(['userStars'])
  @Prop(String) readonly size: Size;
  @Prop(Object) readonly stars: StarObject;

  getIconSize(): string {
    return {
      small: 'fa-3x',
      large: 'fa-5x',
    }[this.size];
  }

  isSmall(): boolean {
    return this.size === 'small';
  }

  isLarge(): boolean {
    return this.size === 'large';
  }

  get cachedStars(): StarObject {
    return this.stars || (this as any).userStars
           || JSON.parse(localStorage.getItem('stars'));
  }
}
</script>